<template>
  <div class="row justify-content-end d-flex align-items-center">
    <span class="d-block text-gray-600 fs-7 w-auto">Filas por página:</span>
    <select
      v-model="cantidad"
      class="form-select w-80px pt-1 pb-1 border-0 cursor-pointer"
      aria-label="Default select example"
      @change="actualizarCantidad()"
    >
      <option
        v-for="(cant, index) in cantidades"
        :key="index"
        :value="cant"
      >
        {{ cant }}
      </option>
    </select>
    <span class="d-block text-gray-600 fs-7 w-auto">{{ (pagina-1)*cantidad+1 }}-{{ (pagina*cantidad) > cantidadFilas ? cantidadFilas : (pagina*cantidad) }} de {{ cantidadFilas }}</span>
    <ul class="pagination w-auto">
      <li class="page-item previous">
        <a
          href="javascript:void(0)"
          @click="primeraPagina()"
        >
          <i :class="['medium material-icons', pagina === 1 ? 'text-gray-400' : 'text-gray-600 text-hover-dark']">first_page</i>
        </a>
      </li>
      <li class="page-item previous disabled">
        <a
          href="javascript:void(0)"
          @click="anteriorPagina()"
        >
          <i :class="['medium material-icons', pagina === 1 ? 'text-gray-400' : 'text-gray-600 text-hover-dark']">keyboard_arrow_left</i>
        </a>
      </li>
      <li class="page-item previous disabled">
        <a
          href="javascript:void(0)"
          @click="siguientePagina()"
        >
          <i :class="['medium material-icons', pagina === limitePagina ? 'text-gray-400' : 'text-gray-600 text-hover-dark']">keyboard_arrow_right</i>
        </a>
      </li>
      <li class="page-item next">
        <a
          href="javascript:void(0)"
          @click="ultimaPagina()"
        >
          <i :class="['medium material-icons', pagina === limitePagina ? 'text-gray-400' : 'text-gray-600 text-hover-dark']">last_page</i>
        </a>
      </li>
    </ul>
  </div>
</template>
<script>
import TablaFila from "@/core/util/TablaFila";

export default {
  name: 'PaginacionPersonalizada2',
  props: {
    cantidades: {type: Array, required: true},
    datos: {type: Array, required: true},
  },
  emits: ['onMostrarPagina'],
  data() {
    return {
      cantidad: 5,
      pagina: 1,
      limitePagina: 1,
      cantidadFilas: 0,
      datosPaginados: []
    }
  },

  watch: {
    cantidades: function(values) {
      this.cantidad = values[0];
    },
    datos: function(values) {
      this.reiniciarPaginacion(values.length);
      this.calcularFilasMostrar();
    }
  },

  mounted() {
    this.cantidad = this.cantidades[0];
  },
  methods: {
    getCantidad() {
      return this.cantidad;
    },
    getPagina() {
      return this.pagina;
    },
    calcularFilasMostrar() {
      this.datosPaginados = TablaFila.getFilasPagina(this.datos, this.pagina, this.cantidad);
      this.$emit('onMostrarPagina', this.datosPaginados);
    },

    primeraPagina() {
      if(this.pagina > 1) {
        this.pagina = 1;
        this.calcularFilasMostrar();
      }
    },
    anteriorPagina() {
      if(this.pagina > 1) {
        this.pagina--;
        this.calcularFilasMostrar();
      }
    },
    siguientePagina() {
      if(this.pagina < this.limitePagina) {
        this.pagina++;
        this.calcularFilasMostrar();
      }
    },
    ultimaPagina() {
      if(this.pagina < this.limitePagina) {
        this.pagina = this.limitePagina;
        this.calcularFilasMostrar();
      }
    },
    actualizarCantidad() {
      this.pagina = 1;
      this.calcularFilasMostrar();
      this.calcularLimitePagina();
    },
    reiniciarPaginacion(cantidadFilas) {
      this.cantidad = this.cantidades[0];
      this.pagina = 1;
      this.cantidadFilas = cantidadFilas;
      this.calcularLimitePagina();
    },
    calcularLimitePagina() {
      this.limitePagina =
          Math.trunc(this.cantidadFilas / this.cantidad) + (this.cantidadFilas % this.cantidad === 0 ? 0 : 1);
    },
  }
}
</script>